
; simple vu macros, try not to go overboard!

	.macro	loadMat	name,offset,basereg
	lq			\name[0],\offset(\basereg)
	lq			\name[1],\offset+1(\basereg)
	lq			\name[2],\offset+2(\basereg)
	lq			\name[3],\offset+3(\basereg)
	.endm

	.macro	isetiu	reg,val
	iaddiu	\reg,vi00,\val
	.endm


	.macro	mulMat	out,inL,inR
	
	mul	acc,\inR[0],\inL[0][x]
	madd	acc,\inR[1],\inL[0][y]
	madd	acc,\inR[2],\inL[0][z]
	madd	\out[0],\inR[3],\inL[0][w]

	mul	acc,\inR[0],\inL[1][x]
	madd	acc,\inR[1],\inL[1][y]
	madd	acc,\inR[2],\inL[1][z]
	madd	\out[1],\inR[3],\inL[1][w]
	
	mul	acc,\inR[0],\inL[2][x]
	madd	acc,\inR[1],\inL[2][y]
	madd	acc,\inR[2],\inL[2][z]
	madd	\out[2],\inR[3],\inL[2][w]
	
	mul	acc,\inR[0],\inL[3][x]
	madd	acc,\inR[1],\inL[3][y]
	madd	acc,\inR[2],\inL[3][z]
	madd	\out[3],\inR[3],\inL[3][w]
	
	.endm





	.macro	loixyzw	reg,xval,yval,zval,wval
	
	loi		\xval
	addi.x	\reg,vf00,i

	loi		\yval
	addi.y	\reg,vf00,i

	loi		\zval
	addi.z	\reg,vf00,i

	loi		\wval
	muli.w	\reg,vf00,i

	.endm

	.macro	loix	reg,val
	loi	\val
	addi.x	\reg,vf00,i
	.endm

 	.macro	loiy	reg,val
	loi	\val
	addi.y	\reg,vf00,i
	.endm

 	.macro	loiz	reg,val
	loi	\val
	addi.z	\reg,vf00,i
	.endm

 	.macro	loiw	reg,val
	loi	\val
	muli.w	\reg,vf00,i
	.endm


	.macro	getONEl
	rinit	r,vf00x
	rget	ONE,R
     ;	maxw	ONE,vf00,vf00
	.endm

	.macro	getONEu
   maxw	ONE,vf00,vf00
	.endm

	

	.macro	normalise_q_x	norm,vec
	mul.xyz	tmp,\vec,\vec
	adday.x	acc,tmp,tmp
	maddz.x	tmp,ONE,tmp
	rsqrt		q,vf00[w],tmp[x]
	mulq.xyz	\norm,\vec,q   		; norm is normal in dof
	.endm

	.macro	normalise_p_y	norm,vec
	mul.xyz	tmp,\vec,\vec
	addax.y	acc,tmp,tmp
	maddz.y	tmp,ONE,tmp
	ersqrt 	p,tmp[y]
	mfp.w		rcpsq,p
	mulw.xyz	\norm,\vec,rcpsq   		; norm is normal in dof
	.endm
	



	.macro	randm	reg,seed,mul,add

	mul		acc,\seed,\mul
	madd		tmp\@,\add,vf00[w]
	move		\reg,\seed

	ftoi0		itmp\@,tmp\@
	itof0		ftmp\@,itmp\@

	sub		\seed,tmp\@,ftmp\@
	.endm

	
	.macro	normlen	norm,vec

	mul.xyz 	tmp\@,\vec,\vec
	move.xyz	\norm,\vec				; norm.xyz = vec

	mul.w		acc,vf00,tmp\@[x]
	madd.w 	acc,vf00,tmp\@[y]
	madd.w	\norm,vf00,tmp\@[z] 	; norm.w = |vec|^2
	rsqrt		q,vf00[w],\norm[w]  	
	mul		\norm,\norm,q			; norm.w= |vec|

	.endm


